// u_00_xxx
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_p_10_no_generics_list;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Memo1: TMemo;
    c_person__tlist_: TButton;
    generic_person_list_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure c_person__tlist_Click(Sender: TObject);
    procedure generic_person_list_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses Generics.Collections
      , u_display_simple
      , u_c_person
      , u_c_non_generic_person_list
      ;

    {$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        Left:= 170; Top:= 110;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    var g_c_person_list: tList= Nil;

    procedure TForm1.c_person__tlist_Click(Sender: TObject);
      var l_c_person: c_person;
      begin
        g_c_person_list:= tList.Create;
        g_c_person_list.Add(c_person.create_person('mike', 24));
        g_c_person_list.Add(c_person.create_person('anna', 18));

        l_c_person:= c_person(g_c_person_list[1]);        // <=== casting

        display(l_c_person.ToString);
      end; // c_person__tlist_Click

    var g_c_generic_person_list: tList<c_person>= Nil;

    procedure TForm1.generic_person_list_Click(Sender: TObject);
      var l_c_person: c_person;
      begin
        g_c_generic_person_list:= tList<c_person>.Create;

        g_c_generic_person_list.Add(c_person.create_person('mike', 24));
        g_c_generic_person_list.Add(c_person.create_person('anna', 18));

        l_c_person:= g_c_generic_person_list[1];

        display(l_c_person.ToString);

        g_c_generic_person_list.Free;
      end; // generic_person_list_Click

    end.

